package contapalavras;

import java.util.ArrayList;

public class ContagemArrayList implements Contagem {

    private final ArrayList<PalavraFreq> tabela;

    public ContagemArrayList() {
        tabela = new ArrayList<>();
    }

    @Override
    public void adiciona(String palavra) {
        PalavraFreq entrada = getEntrada(palavra);
        if (entrada != null) {
            entrada.freq++;
        } else {
            tabela.add(new PalavraFreq(palavra));
        }
    }

    @Override
    public int getFrequencia(String palavra) {
        PalavraFreq entrada = getEntrada(palavra);
        if (entrada == null) {
            return 0;
        } else {
            return entrada.freq;
        }
    }

    @Override
    public String[] getMaisFrequentes(int quantidade) {
        tabela.sort((a, b) -> Integer.compare(b.freq, a.freq));
        String[] mais = new String[quantidade];
        for (int i = 0; i < quantidade; i++) {
            mais[i] = tabela.get(i).palavra;
        }
        return mais;
    }

    private PalavraFreq getEntrada(String palavra) {
        for (PalavraFreq entrada : tabela) {
            if (entrada.palavra.equals(palavra)) {
                return entrada;
            }
        }
        return null;
    }
}

class PalavraFreq {

    final String palavra;
    int freq;

    public PalavraFreq(String palavra) {
        this.palavra = palavra;
        this.freq = 1;
    }
}
