package contapalavras;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map.Entry;

public class ContagemHashMap implements Contagem {

    private final HashMap<String, Integer> frequencia;

    public ContagemHashMap() {
        this.frequencia = new HashMap<>();
    }

    @Override
    public void adiciona(String palavra) {
        frequencia.put(palavra, getFrequencia(palavra) + 1);
    }

    @Override
    public int getFrequencia(String palavra) {
        return frequencia.getOrDefault(palavra, 0);
    }

    @Override
    public String[] getMaisFrequentes(int quantidade) {
        Entry<String, Integer>[] palavras = frequencia
                .entrySet()
                .toArray(new Entry[frequencia.size()]);
        Arrays.sort(palavras, Entry.comparingByValue());
        String[] mais = new String[quantidade];
        for (int i = 0; i < quantidade; i++) {
            mais[i] = palavras[palavras.length - i - 1].getKey();
        }
        return mais;
    }
}
