package contapalavras;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.io.StringReader;
import org.junit.Test;
import static org.junit.Assert.*;

public class ContaPalavrasTest {

    @Test
    public void testAdicionaPalavras() {
        Contagem contagem = new ContagemArrayList();
        ContaPalavras contaPalavras = new ContaPalavras(contagem);
        StringReader reader = new StringReader(
                "casa, [casa] casa2 nada,; de\n  \n\"casa-nada\""
        );
        contaPalavras.adicionaPalavras(reader);
        assertEquals(4, contagem.getFrequencia("casa"));
        assertEquals(2, contagem.getFrequencia("nada"));
        assertEquals(1, contagem.getFrequencia("de"));
    }

    @Test
    public void testExibe() {
        Contagem contagem = new ContagemArrayList();
        contagem.adiciona("nada");
        contagem.adiciona("nada");
        contagem.adiciona("casa");
        contagem.adiciona("casa");
        contagem.adiciona("casa");
        contagem.adiciona("casa");
        contagem.adiciona("carro");
        ContaPalavras contaPalavras = new ContaPalavras(contagem);
        ByteArrayOutputStream output = new ByteArrayOutputStream();
        contaPalavras.exibeMaisFrequentes(new PrintStream(output), 2);
        assertEquals("casa 4\nnada 2\n", output.toString());
    }
}
