package contapalavras;

import org.junit.Test;
import static org.junit.Assert.*;
import org.junit.Ignore;

@Ignore
public abstract class ContagemTest {

    abstract Contagem createContagem();

    @Test
    public void testAdicionaFreq() {
        Contagem contagem = createContagem();

        assertEquals(0, contagem.getFrequencia("casa"));
        assertEquals(0, contagem.getFrequencia("carro"));

        contagem.adiciona("casa");

        assertEquals(1, contagem.getFrequencia("casa"));
        assertEquals(0, contagem.getFrequencia("carro"));

        contagem.adiciona("casa");

        assertEquals(2, contagem.getFrequencia("casa"));
        assertEquals(0, contagem.getFrequencia("carro"));

        contagem.adiciona("carro");

        assertEquals(2, contagem.getFrequencia("casa"));
        assertEquals(1, contagem.getFrequencia("carro"));
    }

    @Test
    public void testGetMaisFrequentes() {
        Contagem contagem = createContagem();
        contagem.adiciona("casa");
        contagem.adiciona("carro");
        contagem.adiciona("banana");
        contagem.adiciona("casa");
        contagem.adiciona("casa");
        contagem.adiciona("banana");
        assertArrayEquals(
                new String[]{"casa"},
                contagem.getMaisFrequentes(1));
        assertArrayEquals(
                new String[]{"casa", "banana"},
                contagem.getMaisFrequentes(2));
        assertArrayEquals(
                new String[]{"casa", "banana", "carro"},
                contagem.getMaisFrequentes(3));
    }
}
